%global         product_id dogtag-jss

%global major_version %%(echo %{version} | cut -d. -f1)
%global minor_version %%(echo %{version} | cut -d. -f2)
%global update_version %%(echo %{version} | cut -d. -f3)

%global java_devel java-17-devel
%global java_headless java-17-headless
%global java_home %{_jvmdir}/jre-17

%bcond_without javadoc
%bcond_with tests

Summary:        Java Security Services (JSS)
Name:           jss
Version:        5.4.1
Release:        3%{?dist}
License:        MPLv1.1 or GPLv2+ or LGPLv2+
URL:            https://github.com/dogtagpki/jss
Source0:        https://github.com/dogtagpki/jss/archive/refs/tags/v%{version}.tar.gz

BuildRequires:  make cmake >= 3.14 gcc-c++ zip unzip
BuildRequires:  nss-devel >= 3.66 nss-tools >= 3.66
BuildRequires:  %{java_devel} jpackage-utils junit
BuildRequires:  slf4j slf4j-jdk14 apache-commons-lang3 

ExclusiveArch:  %{java_arches}

%description
Java Security Services (JSS) is a java native interface which provides a bridge
for java-based applications to use native Network Security Services (NSS).
This only works with gcj. Other JREs require that JCE providers be signed.

%package -n %{product_id}
Summary:        Java Security Services (JSS)
Requires:       nss >= 3.66 slf4j slf4j-jdk14
Requires:       %{java_headless} jpackage-utils apache-commons-lang3
Obsoletes:      jss < %{version}-%{release}
Provides:       jss = %{version}-%{release}
Provides:       jss = %{major_version}.%{minor_version}
Provides:       %{product_id} = %{major_version}.%{minor_version}

%description -n %{product_id}
Java Security Services (JSS) is a java native interface which provides a bridge
for java-based applications to use native Network Security Services (NSS).
This only works with gcj. Other JREs require that JCE providers be signed.

%if %{with javadoc}
%package -n %{product_id}-javadoc
Summary:        Java Security Services (JSS) Javadocs
Obsoletes:      jss-javadoc < %{version}-%{release}
Provides:       jss-javadoc = %{version}-%{release}
Provides:       jss-javadoc = %{major_version}.%{minor_version}
Provides:       %{product_id}-javadoc = %{major_version}.%{minor_version}

%description -n %{product_id}-javadoc
This package contains the API documentation for JSS.
%endif

%prep
%autosetup -n jss-%{version}

%build
export JAVA_HOME=%{java_home}
export BUILD_OPT=1
export CFLAGS="-g %{optflags}"

modutil -dbdir /etc/pki/nssdb -chkfips true | grep -q enabled && export FIPS_ENABLED=1

./build.sh \
    %{?_verbose:-v} \
    --work-dir=%{_vpath_builddir} \
    --prefix-dir=%{_prefix} \
    --include-dir=%{_includedir} \
    --lib-dir=%{_libdir} \
    --sysconf-dir=%{_sysconfdir} \
    --share-dir=%{_datadir} \
    --cmake=%{__cmake} \
    --java-home=%{java_home} \
    --jni-dir=%{_jnidir} \
    --version=%{version} \
    %{!?with_javadoc:--without-javadoc} \
    %{?with_tests:--with-tests} \
    dist

%install
./build.sh \
    %{?_verbose:-v} \
    --work-dir=%{_vpath_builddir} \
    --install-dir=%{buildroot} \
    install

%files -n %{product_id}
%defattr(-,root,root,-)
%license MPL-1.1.txt gpl.txt lgpl.txt symkey/LICENSE
%doc jss.html
%{_libdir}/*
%{_jnidir}/*

%if %{with javadoc}
%files -n %{product_id}-javadoc
%defattr(-,root,root,-)
%{_javadocdir}/jss/
%endif

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.4.1-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Jul 14 2023 Miaojun Dong <zoedong@tencent.com> - 5.4.1-2
- Fix macro defination

* Thu Jul 13 2023 Miaojun Dong <zoedong@tencent.com> - 5.4.1-1
- Bump version to 5.4.1

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.3.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 25 2023 Miaojun Dong <zoedong@tencent.com> - 5.3.0-1
- update version to 5.3.0

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.2.0-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 16 2023 Xin Cheng <denisecheng@tencent.com> - 5.2.0-1
- Init package
